"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateChannels = exports.isOnlineInterval = exports.intervalIsOnlineTime = exports.intervalCheckUpdateTime = exports.intervalCheckUpdateIdCount = exports.intervalCheckUpdate = exports.countUpdate = exports.checkUpdateDevicesInterval = exports.channels = exports.UpdateDevicesInterval = exports.SetIsOnlineIntervalTime = exports.SetDeviceIntervalUpdateTime = exports.SetDeviceIntervalUpdate = exports.IsOnlineInterval = exports.CallUpdateDevices = exports.CallUpdateDevice = exports.CallGetChannels = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _moment = _interopRequireDefault(require("moment"));

var _Config = require("./Config");

var _countUpdate, _countUpdate2;

var channels = [];
exports.channels = channels;
var updateChannels = [];
exports.updateChannels = updateChannels;
var intervalCheckUpdate = true;
exports.intervalCheckUpdate = intervalCheckUpdate;
var intervalCheckUpdateTime = 10000;
exports.intervalCheckUpdateTime = intervalCheckUpdateTime;
var intervalIsOnlineTime = 1000;
exports.intervalIsOnlineTime = intervalIsOnlineTime;
var intervalCheckUpdateIdCount = 0;
exports.intervalCheckUpdateIdCount = intervalCheckUpdateIdCount;
var checkUpdateDevicesInterval = null;
exports.checkUpdateDevicesInterval = checkUpdateDevicesInterval;
var isOnlineInterval = null;
exports.isOnlineInterval = isOnlineInterval;
var countUpdate = 0;
exports.countUpdate = countUpdate;

var SetDeviceIntervalUpdate = function SetDeviceIntervalUpdate(data) {
  exports.intervalCheckUpdate = intervalCheckUpdate = data;
};

exports.SetDeviceIntervalUpdate = SetDeviceIntervalUpdate;

var SetDeviceIntervalUpdateTime = function SetDeviceIntervalUpdateTime(data) {
  exports.intervalCheckUpdateTime = intervalCheckUpdateTime = data;
};

exports.SetDeviceIntervalUpdateTime = SetDeviceIntervalUpdateTime;

var SetIsOnlineIntervalTime = function SetIsOnlineIntervalTime(data) {
  exports.intervalIsOnlineTime = intervalIsOnlineTime = data;
};

exports.SetIsOnlineIntervalTime = SetIsOnlineIntervalTime;

var UpdateDevicesInterval = function UpdateDevicesInterval(socket, serial) {
  if (checkUpdateDevicesInterval !== null) {
    clearInterval(checkUpdateDevicesInterval);
  }

  exports.checkUpdateDevicesInterval = checkUpdateDevicesInterval = setInterval( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return CallUpdateDevices(socket, serial);

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), intervalCheckUpdateTime);
};

exports.UpdateDevicesInterval = UpdateDevicesInterval;

var IsOnlineInterval = function IsOnlineInterval(socket, serial) {
  if (isOnlineInterval !== null) {
    clearInterval(isOnlineInterval);
  }

  exports.isOnlineInterval = isOnlineInterval = setInterval( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            socket.emit("ccu/isOnline", {
              serial: serial
            });

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), intervalIsOnlineTime);
};

exports.IsOnlineInterval = IsOnlineInterval;

var setUpdateChannels = function setUpdateChannels() {
  exports.updateChannels = updateChannels = channels.filter(function (channel) {
    return _Config.SupportedChannels[channel.channelHssType] !== undefined;
  });
};

var CallGetChannels = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(socket, serial) {
    var request;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _Config.clientRpcJsonIismGetChannels.call({
              "jsonrpc": "2.0",
              "version": "1.1",
              "method": "Event.subscribe",
              "params": {
                "timestamps": "12.06.2022 18:11:07"
              },
              "id": "\"GetChannels\""
            });

          case 2:
            request = _context3.sent;

            if (request.error === null && request.result.length > 0) {
              exports.channels = channels = request.result;
              setUpdateChannels();
              socket.emit("ccu/setChannels", channels);
              socket.emit("ccu/setUpdateChannels", updateChannels);
            } else if (request.error !== null) {
              socket.emit("ccu/getChannelsError", {
                serial: serial,
                request: request
              });
            }

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function CallGetChannels(_x, _x2) {
    return _ref3.apply(this, arguments);
  };
}();

exports.CallGetChannels = CallGetChannels;

var CallUpdateDevice = /*#__PURE__*/function () {
  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(channel, socket, serial) {
    var update;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            console.log("CallUpdateDevice singel", channel, serial);
            _context4.next = 3;
            return _Config.clientRpcJsonIismGetChannel.call({
              "jsonrpc": "2.0",
              "version": "1.1",
              "method": "Event.subscribe",
              "params": {
                "channel": channel
              },
              "id": intervalCheckUpdateIdCount
            });

          case 3:
            update = _context4.sent;
            update.result = [update.result];

            if (update.error === null && update.result.length > 0) {
              _countUpdate = countUpdate++, exports.countUpdate = countUpdate, _countUpdate;
              console.log("ccu/updateChannel", countUpdate);
              console.log(update);
              socket.emit("ccu/updateChannel", {
                serial: serial,
                update: update
              });
            } else if (update.error !== null) {
              console.log("ccu/updateChannelError");
              console.log(update);
              socket.emit("ccu/updateChannelError", {
                serial: serial,
                update: update
              });
            }

          case 6:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function CallUpdateDevice(_x3, _x4, _x5) {
    return _ref4.apply(this, arguments);
  };
}();

exports.CallUpdateDevice = CallUpdateDevice;

var CallUpdateDevices = /*#__PURE__*/function () {
  var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(socket, serial) {
    var unix, update;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            console.log("CallUpdateDevices many", serial, updateChannels.map(function (channel) {
              return channel.name;
            }).join(","));

            if (!intervalCheckUpdate) {
              _context5.next = 8;
              break;
            }

            unix = (0, _moment["default"])().subtract(intervalCheckUpdateTime / 1000, 'seconds').unix();
            _context5.next = 5;
            return _Config.clientRpcJsonIism.call({
              "jsonrpc": "2.0",
              "version": "1.1",
              "method": "Event.subscribe",
              "params": {
                "timestamp": unix,
                "channels": updateChannels.map(function (channel) {
                  return channel.idChannel;
                }).join(",")
              },
              "id": intervalCheckUpdateIdCount
            });

          case 5:
            update = _context5.sent;
            exports.intervalCheckUpdateIdCount = intervalCheckUpdateIdCount = intervalCheckUpdateIdCount + 1;

            if (update.error === null && update.result.length > 0) {
              _countUpdate2 = countUpdate++, exports.countUpdate = countUpdate, _countUpdate2;
              console.log("ccu/updateChannel", countUpdate);
              console.log(update);
              socket.emit("ccu/updateChannel", {
                serial: serial,
                update: update
              });
            } else if (update.error !== null) {
              console.log("ccu/updateChannelError");
              console.log(update);
              socket.emit("ccu/updateChannelError", {
                serial: serial,
                update: update
              });
            }

          case 8:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function CallUpdateDevices(_x6, _x7) {
    return _ref5.apply(this, arguments);
  };
}();

exports.CallUpdateDevices = CallUpdateDevices;