"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _socket = _interopRequireDefault(require("socket.io-client"));

var _homematicXmlrpc = _interopRequireDefault(require("homematic-xmlrpc"));

var _CcuCalls = require("./CcuCalls");

var _Config = require("./Config");

var clientRpc = _homematicXmlrpc["default"].createClient({
  host: '127.0.0.1',
  port: 2001,
  path: "/"
});

var session = null;
var serial = null;
var socket = (0, _socket["default"])(_Config.hostSocket, {
  transports: ["websocket"],
  rejectUnauthorized: false,
  secure: true,
  reconnection: true
});
socket.on("connect", /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(e) {
    var resSerial;
    return _regenerator["default"].wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            console.log("connect");
            _context8.next = 3;
            return _Config.clientRpcJsonIismSerial.call({
              "jsonrpc": "2.0",
              version: "1.1",
              "method": "CCU.getSerial",
              "params": {
                "_session_id_": session
              },
              "id": 1
            });

          case 3:
            resSerial = _context8.sent;
            serial = resSerial.serial;
            console.log("serial", serial);
            socket.emit("ccu/connectCcu", serial);
            (0, _CcuCalls.IsOnlineInterval)(socket, serial);
            _context8.next = 10;
            return (0, _CcuCalls.CallGetChannels)(socket, serial);

          case 10:
            (0, _CcuCalls.UpdateDevicesInterval)(socket, serial);
            socket.on('intervalCheckUpdate', function (data) {
              (0, _CcuCalls.SetDeviceIntervalUpdate)(data);
            });
            socket.on('intervalCheckUpdateTime', function (data) {
              (0, _CcuCalls.SetDeviceIntervalUpdateTime)(data);
              (0, _CcuCalls.UpdateDevicesInterval)(socket, serial);
            });
            socket.on('intervalIsOnlineTime', function (data) {
              (0, _CcuCalls.SetIsOnlineIntervalTime)(data);
              (0, _CcuCalls.IsOnlineInterval)(socket, serial);
            });
            socket.on('isOnline', function () {
              socket.emit("ccu/isOnline", serial);
            });
            socket.on('callRpcJson', /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(data) {
                var resCallRpcJson;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        console.log("callRpcJson");
                        data.params["_session_id_"] = session;
                        _context.next = 4;
                        return _Config.clientRpcJsonIismService.call({
                          "jsonrpc": "2.0",
                          version: "1.1",
                          "method": data.method,
                          "params": data.params,
                          "id": data.id
                        });

                      case 4:
                        resCallRpcJson = _context.sent;
                        socket.emit("ccu/callRpcJsonResponse", resCallRpcJson);

                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }());
            socket.on('callRpcXml', function (data) {
              console.log("callRpcXml");
              clientRpc.methodCall(data.method, data.params, function (error, dataResponse) {
                socket.emit("ccu/callRpcXmlResponse", {
                  id: data.id,
                  result: dataResponse
                });
              });
            });
            socket.on('getDeviceValue', /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(data) {
                var address, valueKey, id, resDeviceValue;
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        console.log("getDeviceValue");
                        address = data.address, valueKey = data.valueKey, id = data.id;
                        _context2.next = 4;
                        return _Config.clientRpcJsonIismService.call({
                          "jsonrpc": "2.0",
                          version: "1.1",
                          "method": "Interface.getValue",
                          "params": {
                            "_session_id_": session,
                            address: address,
                            "interface": data["interface"],
                            valueKey: valueKey
                          },
                          id: id
                        });

                      case 4:
                        resDeviceValue = _context2.sent;
                        socket.emit("ccu/getDeviceValueResponse", resDeviceValue);

                      case 6:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }());
            socket.on('setDeviceValue', /*#__PURE__*/function () {
              var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(data) {
                var address, valueKey, type, value, id, resDeviceValue;
                return _regenerator["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        address = data.address, valueKey = data.valueKey, type = data.type, value = data.value, id = data.id;
                        _context3.next = 3;
                        return _Config.clientRpcJsonIismService.call({
                          "jsonrpc": "2.0",
                          version: "1.1",
                          "method": "Interface.setValue",
                          "params": {
                            "_session_id_": session,
                            address: address,
                            "interface": data["interface"],
                            valueKey: valueKey,
                            type: type,
                            value: value
                          },
                          id: id
                        });

                      case 3:
                        resDeviceValue = _context3.sent;
                        _context3.next = 6;
                        return (0, _CcuCalls.CallUpdateDevice)(data.channelId, socket, serial);

                      case 6:
                        socket.emit("ccu/setDeviceValueResponse", {
                          resDeviceValue: resDeviceValue,
                          data: data
                        });

                      case 7:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x4) {
                return _ref4.apply(this, arguments);
              };
            }());
            socket.on('setChannelName', /*#__PURE__*/function () {
              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(data) {
                var id, name, resDeviceValue;
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        console.log("setChannelName");
                        id = data.id, name = data.name;
                        _context4.next = 4;
                        return _Config.clientRpcJsonIismService.call({
                          "jsonrpc": "2.0",
                          version: "1.1",
                          "method": "Channel.setName",
                          "params": {
                            "_session_id_": session,
                            id: id,
                            name: name
                          },
                          id: id
                        });

                      case 4:
                        resDeviceValue = _context4.sent;
                        socket.emit("ccu/setChannelNameResponse", {
                          resDeviceValue: resDeviceValue,
                          data: data
                        });

                      case 6:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));

              return function (_x5) {
                return _ref5.apply(this, arguments);
              };
            }());
            socket.on('setDeviceName', /*#__PURE__*/function () {
              var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(data) {
                var id, name, resDeviceValue;
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        console.log("setDeviceName");
                        id = data.id, name = data.name;
                        _context5.next = 4;
                        return _Config.clientRpcJsonIismService.call({
                          "jsonrpc": "2.0",
                          version: "1.1",
                          "method": "Device.setName",
                          "params": {
                            "_session_id_": session,
                            id: id,
                            name: name
                          },
                          id: id
                        });

                      case 4:
                        resDeviceValue = _context5.sent;
                        socket.emit("ccu/setChannelNameResponse", {
                          resDeviceValue: resDeviceValue,
                          data: data
                        });

                      case 6:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              return function (_x6) {
                return _ref6.apply(this, arguments);
              };
            }());
            socket.on('getRooms', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
              var roomsRpc;
              return _regenerator["default"].wrap(function _callee6$(_context6) {
                while (1) {
                  switch (_context6.prev = _context6.next) {
                    case 0:
                      console.log("getRooms");
                      _context6.next = 3;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Room.getAll",
                        "params": {
                          "_session_id_": session
                        },
                        "id": 0
                      });

                    case 3:
                      roomsRpc = _context6.sent;

                      if (roomsRpc.result !== null) {
                        console.log("getRooms end");
                        socket.emit("ccu/setRooms", {
                          result: roomsRpc.result,
                          serial: serial
                        });
                      }

                    case 5:
                    case "end":
                      return _context6.stop();
                  }
                }
              }, _callee6);
            })));
            socket.on('getDevices', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
              var devices, devicesRpc, i, deviceObject, device, deviceParameterMaster, deviceParameterValue, ci, channel, channelParameterMaster, channelParameterValue;
              return _regenerator["default"].wrap(function _callee7$(_context7) {
                while (1) {
                  switch (_context7.prev = _context7.next) {
                    case 0:
                      console.log("getDevices");
                      devices = [];
                      _context7.next = 4;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Device.listAll",
                        "params": {
                          "_session_id_": session
                        },
                        "id": 0
                      });

                    case 4:
                      devicesRpc = _context7.sent;

                      if (!(devicesRpc.result !== null)) {
                        _context7.next = 40;
                        break;
                      }

                      i = 0;

                    case 7:
                      if (!(i < devicesRpc.result.length)) {
                        _context7.next = 40;
                        break;
                      }

                      deviceObject = devicesRpc.result[i];
                      _context7.next = 11;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Device.get",
                        "params": {
                          "_session_id_": session,
                          "id": deviceObject
                        },
                        "id": 0
                      });

                    case 11:
                      device = _context7.sent;

                      if (!(device.result !== null)) {
                        _context7.next = 35;
                        break;
                      }

                      _context7.next = 15;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Interface.getParamset",
                        "params": {
                          "_session_id_": session,
                          "interface": device.result["interface"],
                          "address": device.result.address,
                          "paramsetKey": "MASTER"
                        },
                        "id": 0
                      });

                    case 15:
                      deviceParameterMaster = _context7.sent;

                      if (deviceParameterMaster.result !== null) {
                        device.result.masterParams = deviceParameterMaster.result;
                      }

                      _context7.next = 19;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Interface.getParamset",
                        "params": {
                          "_session_id_": session,
                          "interface": device.result["interface"],
                          "address": device.result.address,
                          "paramsetKey": "VALUE"
                        },
                        "id": 0
                      });

                    case 19:
                      deviceParameterValue = _context7.sent;

                      if (deviceParameterValue.result !== null) {
                        device.result.valueParams = deviceParameterValue.result;
                      }

                      ci = 0;

                    case 22:
                      if (!(ci < device.result.channels.length)) {
                        _context7.next = 35;
                        break;
                      }

                      channel = device.result.channels[ci];
                      _context7.next = 26;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Interface.getParamsetDescription",
                        "params": {
                          "_session_id_": session,
                          "interface": device.result["interface"],
                          "address": channel.address,
                          "paramsetKey": "MASTER"
                        },
                        "id": 0
                      });

                    case 26:
                      channelParameterMaster = _context7.sent;

                      if (channelParameterMaster.result !== null) {
                        device.result.channels[ci].masterParams = channelParameterMaster.result;
                        /*for (let cmi=0; cmi < device.result.channels[ci].masterParams.length; cmi++) {
                          let paramMaster = device.result.channels[ci].masterParams[cmi];
                          let parameterMasterValue = await clientRpcJson.call(
                            {
                              "jsonrpc": "2.0",
                              version: "1.1",
                              "method": "Interface.getMasterValue",
                              "params": { "_session_id_": session, "interface": device.result.interface, "address": channel.address, "valueKey": paramMaster.NAME },
                              "id": 0
                            });
                          if (parameterMasterValue.result !== null) {
                            device.result.channels[ci].masterParams[cmi].value = parameterMasterValue.result
                          }
                        }*/
                      }

                      _context7.next = 30;
                      return _Config.clientRpcJsonIismService.call({
                        "jsonrpc": "2.0",
                        version: "1.1",
                        "method": "Interface.getParamsetDescription",
                        "params": {
                          "_session_id_": session,
                          "interface": device.result["interface"],
                          "address": channel.address,
                          "paramsetKey": "VALUE"
                        },
                        "id": 0
                      });

                    case 30:
                      channelParameterValue = _context7.sent;

                      if (channelParameterValue.result !== null) {
                        device.result.channels[ci].valueParams = channelParameterValue.result;
                        /*for (let cvi=0; cvi < device.result.channels[ci].valueParams.length; cvi++) {
                          let paramMaster = device.result.channels[ci].valueParams[cvi];
                          let parameterMasterValue = await clientRpcJson.call(
                            {
                              "jsonrpc": "2.0",
                              version: "1.1",
                              "method": "Interface.getMasterValue",
                              "params": { "_session_id_": session, "interface": device.result.interface, "address": channel.address, "valueKey": paramMaster.NAME },
                              "id": 0
                            });
                          if (parameterMasterValue.result !== null) {
                            device.result.channels[ci].valueParams[cvi].value = parameterMasterValue.result
                          }
                        }*/
                      }

                    case 32:
                      ci++;
                      _context7.next = 22;
                      break;

                    case 35:
                      devices.push(device.result);

                      if (i === devicesRpc.result.length - 1) {
                        socket.emit("ccu/setDevices", {
                          devices: devices,
                          serial: serial
                        });
                      }

                    case 37:
                      i++;
                      _context7.next = 7;
                      break;

                    case 40:
                      console.log("getDevices end");

                    case 41:
                    case "end":
                      return _context7.stop();
                  }
                }
              }, _callee7);
            })));

          case 23:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());
/*
clientRpc.methodCall('listBidcosInterfaces', [], function (error, devices) {

  //console.log(devices)
})
clientRpc.methodCall('init', [], function (error, devices) {
  clientRpc.methodCall('listDevices', [], function (error, devices) {
    //console.log(devices)
    for (let i = 0; i < devices.length; i++) {
      let device = devices[i]
      clientRpc.methodCall('getDeviceDescription', [device.ADDRESS], function (error, device) {
        // console.log(device)
      })
    }
  })
})*/

/*clientRpcJson.call(
  {
    "jsonrpc": "2.0",
    "method": "Interface.getDeviceDescription",
    "params": { "_session_id_": session, "address": "0015DBE99EB2CD:1",
      "interface": "HmIP-RF" },
    "id": 1
  },
  function (err, res) {
    serial = res.result
    console.log("getDeviceDescription", res)
  }
);
clientRpcJson.call(
  {
    "jsonrpc": "2.0",
    "method": "Interface.getParamsetDescription",
    "params": { "_session_id_": session, "address": "0015DBE99EB2CD:2",
      "interface": "HmIP-RF", paramsetKey: "VALUES" },
    "id": 1
  },
  function (err, res) {
    serial = res.result
    console.log("getParamsetDescription", res)
  }
);
*/

/*clientRpcJson.call(
        {
          "jsonrpc": "2.0",
          "method": "Interface.setValue",
          "params": { "_session_id_": session, "address": "0015DBE99EB2CD:2",
            "interface": "HmIP-RF", valueKey: "STATE", type: 'bool', value: "0"  },
          "id": 1
        },
        function (err, res) {
          serial = res.result
          console.log("setValue", res)
        }
      );*/