import fetch from 'node-fetch'

class RcpJsonClient {
  options = {
    port: 80,
    // string domain name or ip of rpc server, default '127.0.0.1'
    host: 'http://127.0.0.1',
    // string with default path, default '/'
    path: '/api/homematic.cgi',
    // boolean false to turn rpc checks off, default true
    strict: true
  }
  constructor(options) {
    this.options = {...options}
  }

  async call(body, query) {
    try {
      const response = await fetch(this.options.host + this.options.path + ((query === undefined) ? "" : query), {
        method: 'POST',
        body: JSON.stringify(body),
        headers: {'Content-Type': 'application/json'}
      });
      if (response.error) {

        console.log("response.error", body, response.error)
      }
      return await response.json();
    } catch (e) {
      console.log("error call", this.options, body, e)
      return false
    }
  }
}

export default RcpJsonClient
