#!/bin/tclsh
package require HomeMatic
cd /www
set central true

# Zentrale oder Konfigtool (/www/ = Zentrale)
if {$env(DOCUMENT_ROOT) != "\/www\/"} then {
  set central false
}

#####################
# Verwendete Module #
#####################
load tclrpc.so

if {$central} then {
  load tclrega.so
}

source [file join $env(DOCUMENT_ROOT) api/eq3/common.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/ipc.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/json.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/jsonrpc.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/hmscript.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/event.tcl]
source session.tcl

set script {
    string id;
    boolean first = true;
    boolean firstChannel = true;
    boolean firstChannelDp = true;
    Write("[")
    firstChannel = true;
    foreach(id, root.Devices().EnumIDs())
      {
        var device = dom.GetObject(id);
        if (true == device.ReadyConfig())
        {

             string channelId;
             string channelHssType = "";
            foreach(channelId, device.Channels())
            {
              var channel = dom.GetObject(channelId);
              string sLastTime = "";
                integer iSeconds = 0;
                if( channel.IsTypeOf( OT_CHANNEL ) )
                {
                  sLastTime = channel.LastDPActionTime();
                  iSeconds = channel.LastDPActionTimeSeconds();
                }
                if( channel.IsTypeOf( OT_DP ) )
                {
                  sLastTime = channel.Timestamp();
                  iSeconds = channel.TimestampSeconds();
                }
                if( channel.IsTypeOf( OT_PROGRAM ) )
                {
                  sLastTime = channel.ProgramLastExecuteTime();
                  iSeconds = channel.ProgramLastExecuteTimeSeconds();
                }
                if( iSeconds == 0 )
                {
                  sLastTime = "";
                }
                else
                {
                  sLastTime = sLastTime.Format("%d.%m.%Y %H:%M:%S");
                }
                   if (true != firstChannel) { Write(","); } else { firstChannel = false; }

                   Write("{");
                   Write("\"idChannel\":\"")
                   Write(channel.ID())
                   Write("\"")
                   Write(",\"idDevice\":\"")
                   Write(device.ID())
                   Write("\"")
                   Write(",\"sLastTime\":\"")
                   Write(sLastTime)
                   Write("\"")
                   Write(",\"time\":\"")
                    Write(iSeconds.ToInteger())
                    Write("\"")
                    Write(",\"address\":\"")
                    Write(channel.Address())
                    Write("\"")
                    Write(",\"name\":\"")
                    Write(channel.Name())
                    Write("\"")
                    Write(",\"deviceHssType\":\"")
                   Write(device.HssType())
                   Write("\"")
                   Write(",\"channelHssType\":\"")
                   Write(channel.HssType())
                   Write("\"")
                   Write("}")
                  }

            }
      }
      Write("]")
}

#https://ccu3-webui.fritz.box/addons/iism/bin/poll.cgi?sid=@WOKsnh7u8o@
array set JSONRPC    ""
set JSONRPC(METHOD)  ""
set JSONRPC(PARAMS)  ""
set JSONRPC(ID)     "\"error\""
set JSONRPC(ID_USED) 1
proc jsonrpc_parse_2 {request} {
  global JSONRPC JSONRPC_ERROR

#  set request [string range $request 1 end]
  if { [catch { array set parsedRequest [encoding convertfrom identity [json_parse $request]]} errMsg] } then {
     jsonrpc_error 100 "invalid request ($errMsg)"
  }
  if { [catch { set JSONRPC(ID) $parsedRequest(id)} ] } then {
    set JSONRPC(ID_USED) 0
  }
  if { [catch { set JSONRPC(PARAMS) $parsedRequest(params)} ] } then {
    jsonrpc_error 103 "params not found in request"
  }
}
if {$env(REQUEST_METHOD) == "POST"} then {
  if { [catch {
    jsonrpc_parse_2 [read stdin $env(CONTENT_LENGTH)]
    array set args   $JSONRPC(PARAMS)

    jsonrpc_response [hmscript $script args]
  }] } then {
    jsonrpc_error 200 "internal error:\n$errorInfo"
  }
}

