##
# Interface.deleteDevice
# Lscht ein Gert aus der Schnittstelle
#
# Parameter:
#   inteface: [string]  Bezeichnung der Schnittstelle
#   address:  [string]  Adresse des logischen Gerts
#   flags:    [integer] Flags
#                       0x01: [DELTE_FLAG_RESET]  Setzt das Gert in den Werkszustand zurck
#                       0x02: [DELETE_FLAG_FORCE] Lscht das Gert auch, wenn dieses nicht erreichbar ist
#                       0x04: [DELETE_FLAG_DEFER] Lscht das Gert bei der nchsten Gelegenheit
#
# Rckgabewert: [boolean]
#   true (Falls das Gert nicht gelscht werden kann, tritt eine Exception auf)
##

set address $args(address)
set flags   $args(flags)

checkXmlRpcStatus [catch {xmlrpc $interface(URL) deleteDevice [list string $address] [list int $flags] }]

jsonrpc_response true