#!/bin/tclsh
package require HomeMatic
cd /www
set central true

# Zentrale oder Konfigtool (/www/ = Zentrale)
if {$env(DOCUMENT_ROOT) != "\/www\/"} then {
  set central false
}

#####################
# Verwendete Module #
#####################
load tclrpc.so

if {$central} then {
  load tclrega.so
}

source [file join $env(DOCUMENT_ROOT) api/eq3/common.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/ipc.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/json.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/jsonrpc.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/hmscript.tcl]
source [file join $env(DOCUMENT_ROOT) api/eq3/event.tcl]
source session.tcl

#if ( ((channel.HssType() == "SHUTTER_TRANSMITTER") || (channel.HssType() == "BLIND_TRANSMITTER") || (channel.HssType() == "SWITCH_VIRTUAL_RECEIVER") || (channel.HssType() == "CLIMATE_TRANSCEIVER")) && (sLastTime != "") && ( iSeconds.ToInteger() >= system.GetVar("timestamp").ToInteger() ) ) {

set script {
    string id;
    boolean first = true;
    boolean firstChannel = true;
    boolean firstChannelDp = true;
    Write("[")
    firstChannel = true;
    foreach(id, root.Devices().EnumIDs())
      {
        var device = dom.GetObject(id);
        if (true == device.ReadyConfig())
        {

             string channelId;
             string channelHssType = "";
            foreach(channelId, device.Channels())
            {
              var channel = dom.GetObject(channelId);
              string sLastTime = "";
                integer iSeconds = 0;
                if( channel.IsTypeOf( OT_CHANNEL ) )
                {
                  sLastTime = channel.LastDPActionTime();
                  iSeconds = channel.LastDPActionTimeSeconds();
                }
                if( channel.IsTypeOf( OT_DP ) )
                {
                  sLastTime = channel.Timestamp();
                  iSeconds = channel.TimestampSeconds();
                }
                if( channel.IsTypeOf( OT_PROGRAM ) )
                {
                  sLastTime = channel.ProgramLastExecuteTime();
                  iSeconds = channel.ProgramLastExecuteTimeSeconds();
                }
                if( iSeconds == 0 )
                {
                  sLastTime = "";
                }
                else
                {
                  sLastTime = sLastTime.Format("%d.%m.%Y %H:%M:%S");
                }
                if (
                (
                (channel.HssType() == "DIMMER_VIRTUAL_RECEIVER") ||
                (channel.HssType() == "COND_SWITCH_TRANSMITTER_TEMPERATURE") ||
                (channel.HssType() == "PRESENCEDETECTOR_TRANSCEIVER") ||
                (channel.HssType() == "HEATING_CLIMATECONTROL_TRANSCEIVER") ||
                (channel.HssType() == "SHUTTER_TRANSMITTER") ||
                (channel.HssType() == "BLIND_TRANSMITTER") ||
                (channel.HssType() == "SWITCH_VIRTUAL_RECEIVER") ||
                (channel.HssType() == "CLIMATE_TRANSCEIVER")) &&
                (sLastTime != "") &&
                ( iSeconds.ToInteger() >= system.GetVar("timestamp").ToInteger() ) ) {
                   if (true != firstChannel) { Write(","); } else { firstChannel = false; }

                   Write("{");
                   Write("\"idChannel\":\"")
                   Write(channel.ID())
                   Write("\"")
                   Write(",\"idDevice\":\"")
                   Write(device.ID())
                   Write("\"")
                   Write(",\"sLastTime\":\"")
                   Write(sLastTime)
                   Write("\"")
                   Write(",\"time\":\"")
                    Write(iSeconds.ToInteger())
                    Write("\"")
                    Write(",\"address\":\"")
                    Write(channel.Address())
                    Write("\"")
                    Write(",\"name\":\"")
                    Write(channel.Name())
                    Write("\"")
                    Write(",\"time2\":\"")
                    Write(system.GetVar("timestamp").ToInteger())
                    Write("\"")
                    Write(",\"deviceHssType\":\"")
                   Write(device.HssType())
                   Write("\"")
                   Write(",\"channelHssType\":\"")
                   Write(channel.HssType())
                   Write("\"")

                   if ((channel.HssType() == "CLIMATECONTROL_FLOOR_TRANSCEIVER") || (channel.HssType() == "SHUTTER_CONTACT") || (channel.HssType() == "SWITCH_TRANSMITTER") || (channel.HssType() == "CLIMATE_TRANSCEIVER") || (channel.HssType() == "HEATING_CLIMATECONTROL_TRANSCEIVER")) {
                        var dbTemp = channel.DPByHssDP("ACTUAL_TEMPERATURE");
                        var dbHumi = channel.DPByHssDP("HUMIDITY");
                        Write(",\"ACTUAL_TEMPERATURE\":\"")
                        Write(dbTemp.State())
                        Write("\"")
                        Write(",\"HUMIDITY\":\"")
                        Write(dbHumi.State())
                        Write("\"")
                        Write(",\"ValueTypeStrHUMIDITY\":\"");
                         Write(dbHumi.ValueTypeStr())
                         Write("\"")
                        Write(",\"ValueTypeHUMIDITY\":\"");
                         Write(dbHumi.ValueType())
                         Write("\"")
                        Write(",\"ValueTypeStrACTUAL_TEMPERATURE\":\"");
                         Write(dbTemp.ValueTypeStr())
                         Write("\"")
                        Write(",\"ValueTypeACTUAL_TEMPERATURE\":\"");
                         Write(dbTemp.ValueType())
                         Write("\"")
                   }
                   if ((channel.HssType() == "COND_SWITCH_TRANSMITTER_TEMPERATURE")) {
                                           var dbTemp = channel.DPByHssDP("ACTUAL_TEMPERATURE");
                                           Write(",\"ACTUAL_TEMPERATURE\":\"")
                                           Write(dbTemp.State())
                                           Write("\"")
                                           Write(",\"ValueTypeStrACTUAL_TEMPERATURE\":\"");
                                            Write(dbTemp.ValueTypeStr())
                                            Write("\"")
                                           Write(",\"ValueTypeACTUAL_TEMPERATURE\":\"");
                                            Write(dbTemp.ValueType())
                                            Write("\"")
                                      }
                   if ((channel.HssType() == "HEATING_CLIMATECONTROL_TRANSCEIVER")) {
                                           var dbTemp = channel.DPByHssDP("SET_POINT_TEMPERATURE");
                                           Write(",\"SET_POINT_TEMPERATURE\":\"")
                                           Write(dbTemp.State())
                                           Write("\"")
                                           Write(",\"ValueTypeStrSET_POINT_TEMPERATURE\":\"");
                                            Write(dbTemp.ValueTypeStr())
                                            Write("\"")
                                           Write(",\"ValueTypeSET_POINT_TEMPERATURE\":\"");
                                            Write(dbTemp.ValueType())
                                            Write("\"")
                                      }
                   if ((channel.HssType() == "DIMMER_VIRTUAL_RECEIVER") || (channel.HssType() == "CLIMATECONTROL_FLOOR_TRANSCEIVER") || (channel.HssType() == "BLIND_TRANSMITTER") || (channel.HssType() == "SHUTTER_TRANSMITTER")) {
                       var dbLevel = channel.DPByHssDP("LEVEL");
                       Write(",\"LEVEL\":\"")
                       Write(dbLevel.State())
                       Write("\"")
                        Write(",\"ValueTypeStrLEVEL\":\"");
                         Write(dbLevel.ValueTypeStr())
                         Write("\"")
                        Write(",\"ValueTypeSTATE\":\"");
                         Write(dbLevel.ValueType())
                         Write("\"")
                  }
                  if ((channel.HssType() == "BRIGHTNESS_TRANSMITTER")) {
                                         var dbAVERAGE_ILLUMINATION = channel.DPByHssDP("AVERAGE_ILLUMINATION");
                                         var dbCURRENT_ILLUMINATION = channel.DPByHssDP("CURRENT_ILLUMINATION");
                                         var dbHIGHEST_ILLUMINATION = channel.DPByHssDP("HIGHEST_ILLUMINATION");
                                         var dbLOWEST_ILLUMINATION = channel.DPByHssDP("LOWEST_ILLUMINATION");
                                         Write(",\"AVERAGE_ILLUMINATION\":\"")
                                         Write(dbAVERAGE_ILLUMINATION.State())
                                         Write("\"")
                                          Write(",\"ValueTypeStrAVERAGE_ILLUMINATION\":\"");
                                           Write(dbAVERAGE_ILLUMINATION.ValueTypeStr())
                                           Write("\"")
                                          Write(",\"ValueTypeAVERAGE_ILLUMINATION\":\"");
                                           Write(dbAVERAGE_ILLUMINATION.ValueType())
                                           Write("\"")
                                           Write(",\"CURRENT_ILLUMINATION\":\"")
                                        Write(dbCURRENT_ILLUMINATION.State())
                                        Write("\"")
                                         Write(",\"ValueTypeStrCURRENT_ILLUMINATION\":\"");
                                          Write(dbCURRENT_ILLUMINATION.ValueTypeStr())
                                          Write("\"")
                                         Write(",\"ValueTypeCURRENT_ILLUMINATION\":\"");
                                          Write(dbCURRENT_ILLUMINATION.ValueType())
                                          Write("\"")
                                           Write(",\"HIGHEST_ILLUMINATION\":\"")
                                        Write(dbHIGHEST_ILLUMINATION.State())
                                        Write("\"")
                                         Write(",\"ValueTypeStrHIGHEST_ILLUMINATION\":\"");
                                          Write(dbHIGHEST_ILLUMINATION.ValueTypeStr())
                                          Write("\"")
                                         Write(",\"ValueTypeHIGHEST_ILLUMINATION\":\"");
                                          Write(dbHIGHEST_ILLUMINATION.ValueType())
                                          Write("\"")
                                          Write(",\"LOWEST_ILLUMINATION\":\"")
                                          Write(dbLOWEST_ILLUMINATION.State())
                                          Write("\"")
                                           Write(",\"ValueTypeStrLOWEST_ILLUMINATION\":\"");
                                            Write(dbLOWEST_ILLUMINATION.ValueTypeStr())
                                            Write("\"")
                                           Write(",\"ValueTypeLOWEST_ILLUMINATION\":\"");
                                            Write(dbLOWEST_ILLUMINATION.ValueType())
                                            Write("\"")
                                    }
                    if ((channel.HssType() == "PRESENCEDETECTOR_TRANSCEIVER")) {
                         var dbCURRENT_ILLUMINATION = channel.DPByHssDP("CURRENT_ILLUMINATION");
                         var dbPRESENCE_DETECTION_ACTIVE = channel.DPByHssDP("PRESENCE_DETECTION_ACTIVE");
                         var dbPRESENCE_DETECTION_STATE = channel.DPByHssDP("PRESENCE_DETECTION_STATE");
                         Write(",\"CURRENT_ILLUMINATION\":\"")
                         Write(dbCURRENT_ILLUMINATION.State())
                         Write("\"")
                          Write(",\"ValueTypeStrCURRENT_ILLUMINATION\":\"");
                           Write(dbCURRENT_ILLUMINATION.ValueTypeStr())
                           Write("\"")
                          Write(",\"ValueTypeCURRENT_ILLUMINATION\":\"");
                           Write(dbCURRENT_ILLUMINATION.ValueType())
                           Write("\"")

                           Write(",\"PRESENCE_DETECTION_ACTIVE\":\"")
                        Write(dbPRESENCE_DETECTION_ACTIVE.State())
                        Write("\"")
                         Write(",\"ValueTypeStrPRESENCE_DETECTION_ACTIVE\":\"");
                          Write(dbPRESENCE_DETECTION_ACTIVE.ValueTypeStr())
                          Write("\"")
                         Write(",\"ValueTypePRESENCE_DETECTION_ACTIVE\":\"");
                          Write(dbPRESENCE_DETECTION_ACTIVE.ValueType())
                          Write("\"")

                          Write(",\"PRESENCE_DETECTION_STATE\":\"")
                       Write(dbPRESENCE_DETECTION_STATE.State())
                       Write("\"")
                        Write(",\"ValueTypeStrPRESENCE_DETECTION_STATE\":\"");
                         Write(dbPRESENCE_DETECTION_STATE.ValueTypeStr())
                         Write("\"")
                        Write(",\"ValueTypePRESENCE_DETECTION_STATE\":\"");
                         Write(dbPRESENCE_DETECTION_STATE.ValueType())
                         Write("\"")
                    }
                  if ((channel.HssType() == "SHUTTER_CONTACT") || (channel.HssType() == "SWITCH_VIRTUAL_RECEIVER") || (channel.HssType() == "SWITCH_TRANSMITTER")) {
                     var dbState = channel.DPByHssDP("STATE");
                     Write(",\"STATE\":\"")
                     Write(dbState.State())
                     Write("\"")
                        Write(",\"ValueTypeStrSTATE\":\"");
                         Write(dbState.ValueTypeStr())
                         Write("\"")
                        Write(",\"ValueTypeSTATE\":\"");
                         Write(dbState.ValueType());
                         Write("\"");
                }
                   Write("}")
                  }

            }
        }
      }
      Write("]")
}

#https://ccu3-webui.fritz.box/addons/iism/bin/poll.cgi?sid=@WOKsnh7u8o@
array set JSONRPC    ""
set JSONRPC(METHOD)  ""
set JSONRPC(PARAMS)  ""
set JSONRPC(ID)     "\"error\""
set JSONRPC(ID_USED) 1
proc jsonrpc_parse_2 {request} {
  global JSONRPC JSONRPC_ERROR

#  set request [string range $request 1 end]
  if { [catch { array set parsedRequest [encoding convertfrom identity [json_parse $request]]} errMsg] } then {
     jsonrpc_error 100 "invalid request ($errMsg)"
  }
  if { [catch { set JSONRPC(ID) $parsedRequest(id)} ] } then {
    set JSONRPC(ID_USED) 0
  }
  if { [catch { set JSONRPC(PARAMS) $parsedRequest(params)} ] } then {
    jsonrpc_error 103 "params not found in request"
  }
}
if {$env(REQUEST_METHOD) == "POST"} then {
  if { [catch {
    jsonrpc_parse_2 [read stdin $env(CONTENT_LENGTH)]
    array set args   $JSONRPC(PARAMS)

    jsonrpc_response [hmscript $script args]
  }] } then {
    jsonrpc_error 200 "internal error:\n$errorInfo"
  }
}

